﻿using StimulsoftSortingBusinessObjects.Domain;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace StimulsoftSortingBusinessObjects.Reports
{
	public class EntityForReport : ICustomTypeDescriptor, IEnumerable
	{
		private object _innerObject;

		public AttributeCollection GetAttributes()
		{
			throw new NotImplementedException();
		}

		public string GetClassName()
		{
			throw new NotImplementedException();
		}

		public string GetComponentName()
		{
			throw new NotImplementedException();
		}

		public TypeConverter GetConverter()
		{
			throw new NotImplementedException();
		}

		public EventDescriptor GetDefaultEvent()
		{
			throw new NotImplementedException();
		}

		public PropertyDescriptor GetDefaultProperty()
		{
			throw new NotImplementedException();
		}

		public object GetEditor(Type editorBaseType)
		{
			throw new NotImplementedException();
		}

		public IEnumerator GetEnumerator()
		{
			return new Enumerator(this);
		}

		public EventDescriptorCollection GetEvents()
		{
			throw new NotImplementedException();
		}

		public EventDescriptorCollection GetEvents(Attribute[] attributes)
		{
			throw new NotImplementedException();
		}

		public PropertyDescriptorCollection GetProperties()
		{
			return new PropertyDescriptorCollection(EntityForReportPropertyDescriptors(_innerObject.GetType().GetProperties().ToList()).ToArray());
		}

		public PropertyDescriptorCollection GetProperties(Attribute[] attributes)
		{
			throw new NotImplementedException();
		}

		public object GetPropertyOwner(PropertyDescriptor pd)
		{
			throw new NotImplementedException();
		}

		private IEnumerable<EntityForReportDescriptorBase> EntityForReportPropertyDescriptors(List<PropertyInfo> properties)
		{
			var result = properties.Select(p => typeof(EntityBase).IsAssignableFrom(p.PropertyType) || typeof(IList).IsAssignableFrom(p.PropertyType) ?
				(EntityForReportDescriptorBase)new EntityForReportRelationDescription(p) :
				 // ? (EntityForReportDescriptorBase)new EntityForReportRelationDescription(p, p.PropertyType.GetGenericArguments()[0]) :
					new EntityForReportPropertyDescriptor(p));
			return result;
		}

		///<summary>
		///</summary>
		///<param name="entityForReport"></param>
		///<returns></returns>
		public static explicit operator EntityBase(EntityForReport entityForReport)
		{
			if (entityForReport == null)
				throw new ArgumentNullException();
			return entityForReport._innerObject as EntityBase;
		}

		#region Constructors

		public EntityForReport(object innerObject)
		{
			_innerObject = innerObject;
		}

		#endregion 

		#region Other members

		private class Enumerator : IEnumerator
		{
			private readonly EntityForReport _entityForReport;
			private bool _first = true;

			public Enumerator(EntityForReport entityForReport)
			{
				_entityForReport = entityForReport;
			}

			public bool MoveNext()
			{
				if (_first)
				{
					_first = false;
					return true;
				}
				return false;
			}

			public void Reset()
			{
				_first = true;
			}

			public object Current
			{
				get { return _entityForReport; }
			}
		}

		#endregion
	}
}
