﻿using StimulsoftSortingBusinessObjects.Domain;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace StimulsoftSortingBusinessObjects.Reports
{
	public class EntityForReportPropertyDescriptor : EntityForReportDescriptorBase
	{
		private PropertyInfo _property;

		public EntityForReportPropertyDescriptor(PropertyInfo property)
			: base(property.Name, property.PropertyType, property.Name)
		{
			_property = property;
		}

		public override object GetValue(object component)
		{
			var entityForReport = component as EntityForReport;
			if (entityForReport != null)
				return _property.GetValue((EntityBase)entityForReport);

			return _property.GetValue(component);
		}
	}
}
