﻿using StimulsoftSortingBusinessObjects.Domain;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace StimulsoftSortingBusinessObjects.Reports
{
	public class EntityForReportRelationDescription : EntityForReportDescriptorBase
	{
		private PropertyInfo _property;

		public override object GetValue(object component)
		{
			var entity = component as EntityForReport;
			if (entity == null)
				throw new InvalidOperationException();

			var instance = (EntityBase)entity;
			if (instance == null)
			{
				return instance;
			}

			var value = _property.GetValue(instance);

			if (value is System.Collections.IList)
			{
				var list = ((System.Collections.IList)value).OfType<EntityBase>().Select(e => new EntityForReport(e)).ToList();

				return list;
			}

			return new EntityForReport(value);
		}

		public EntityForReportRelationDescription(PropertyInfo property)
			: this(property, property.PropertyType)
		{
		}

		public EntityForReportRelationDescription(PropertyInfo property, Type type)
			: base(property.Name, property.PropertyType, property.Name)
		{
			_property = property;
		}
	}
}
